diff --git a/doc/guides/sample_app_ug/intro.rst b/doc/guides/sample_app_ug/intro.rst
index 981e50f94..dcfe70db2 100644
--- a/doc/guides/sample_app_ug/intro.rst
+++ b/doc/guides/sample_app_ug/intro.rst
@@ -31,37 +31,33 @@ applications that are available in the examples directory of DPDK:
  .. table:: **Some of the DPDK Sample applications**
 
     +---------------------------------------+--------------------------------------+
-    | Bonding                               |                                      |
+    | Bonding                               | Packet Ordering                      |
     +---------------------------------------+--------------------------------------+
-    | Command Line                          | Packet Ordering                      |
+    | Command Line                          | Performance Thread                   |
     +---------------------------------------+--------------------------------------+
-    | Distributor                           | Performance Thread                   |
+    | Distributor                           | Precision Time Protocol (PTP) Client |
     +---------------------------------------+--------------------------------------+
-    | Ethtool                               | Precision Time Protocol (PTP) Client |
-    +---------------------------------------+--------------------------------------+
-    |                                       | Quality of Service (QoS) Metering    |
+    | Ethtool                               | Quality of Service (QoS) Metering    |
     +---------------------------------------+--------------------------------------+
     | Hello World                           | QoS Scheduler                        |
     +---------------------------------------+--------------------------------------+
-    | Internet Protocol (IP) Fragmentation  |                                      |
-    +---------------------------------------+--------------------------------------+
-    | IP Pipeline                           | RX/TX Callbacks                      |
+    | Internet Protocol (IP) Fragmentation  | RX/TX Callbacks                      |
     +---------------------------------------+--------------------------------------+
-    | IP Reassembly                         | Server node EFD                      |
+    | IP Pipeline                           | Server node EFD                      |
     +---------------------------------------+--------------------------------------+
-    | IPsec Security Gateway                | Basic Forwarding/Skeleton App        |
+    | IP Reassembly                         | Basic Forwarding/Skeleton App        |
     +---------------------------------------+--------------------------------------+
-    | IPv4 multicast                        | Tunnel End Point (TEP) termination   |
+    | IPsec Security Gateway                | Tunnel End Point (TEP) termination   |
     +---------------------------------------+--------------------------------------+
-    | Kernel NIC Interface                  | Timer                                |
+    | IPv4 multicast                        | Timer                                |
     +---------------------------------------+--------------------------------------+
-    | Network Layer 2 Forwarding + variants | Vhost                                |
+    | Kernel NIC Interface                  | Vhost                                |
     +---------------------------------------+--------------------------------------+
-    | Network Layer 3 Forwarding + variants | Vhost Xen                            |
+    | Network Layer 2 Forwarding + variants | Vhost Xen                            |
     +---------------------------------------+--------------------------------------+
-    | Link Status Interrupt                 | VMDQ Forwarding                      |
+    | Network Layer 3 Forwarding + variants | VMDQ Forwarding                      |
     +---------------------------------------+--------------------------------------+
-    |                                       | VMDQ and DCB Forwarding              |
+    | Link Status Interrupt                 | VMDQ and DCB Forwarding              |
     +---------------------------------------+--------------------------------------+
     | Multi-process                         | VM Power Management                  |
     +---------------------------------------+--------------------------------------+